# -*- encoding: utf-8 -*-

from __future__ import print_function

import argparse
import sys

import productmd.compose
import kobo.rpmlib


from .copy_compose import copy_compose  # noqa


def look_for_build(compose, nvr):
    parts = kobo.rpmlib.parse_nvr(nvr)
    parts["epoch"] = parts["epoch"] or "0"
    srpm_name = "{name}-{epoch}:{version}-{release}.src".format(**parts)

    for variant in compose.rpms.rpms:
        for arch in compose.rpms.rpms[variant]:
            if srpm_name in compose.rpms.rpms[variant][arch]:
                return True

    return False


def has_build(args=None):
    parser = argparse.ArgumentParser()
    parser.add_argument(
        "-q", "--quiet", help="do not print any output", action="store_true"
    )
    parser.add_argument("COMPOSE", help="compose to check")
    parser.add_argument("NVR", help="build to look for")

    opts = parser.parse_args(args)

    compose = productmd.compose.Compose(opts.COMPOSE)
    compose_id = compose.info.compose.id

    if look_for_build(compose, opts.NVR):
        if not opts.quiet:
            print("Compose %s has build %s" % (compose_id, opts.NVR))
    else:
        if not opts.quiet:
            print("Compose %s does not have build %s" % (compose_id, opts.NVR))
        sys.exit(1)
